//
// Portable Integrity Protection (PIP) System -
// Copyright (C) 2015 Secure Systems Laboratory, Stony Brook University
//
// This file is part of Portable Integrity Protection (PIP) System.
//
// Portable Integrity Protection (PIP) System is free software: you can
// redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Portable Integrity Protection (PIP) System is distributed in the hope that it
// will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Portable Integrity Protection (PIP) System.  If not, see
// <http://www.gnu.org/licenses/>.
//

#include "ppi_debug.h"
#include "ppi_utils.h"

char ppi_debug_buffer[PPI_BUFFERPOOL_ENTRY_SIZE];

BOOL ppi_isSpecialProcess(BOOL &checked, BOOL &isSpecial, const wchar_t *specialList[]) {
	if (!checked) {
		if (ppi_utils_wstringInArray(ppi_utils_getProgramPath(), specialList)) {
			isSpecial = TRUE;
		} else
			isSpecial = FALSE;
		checked = TRUE;
	}
	return isSpecial;
}

const wchar_t *ppi_detailedLogProcesses[] = {
	NULL};

BOOL __ppi_isDetailedLogProcess = FALSE;
BOOL __ppi_checkedIsDetailedLogProcess = FALSE;

BOOL ppi_isDetailedLogProcess() {
	return ppi_isSpecialProcess(__ppi_checkedIsDetailedLogProcess, __ppi_isDetailedLogProcess, ppi_detailedLogProcesses);
}



const wchar_t *ppi_newAPIProcesses[] = {
	L"C:\\Program Files\\Git\\bin\\git.exe",
	L"C:\\Windows\\system32\\NOTEPAD.EXE",
	L"C:\\pip-windows\\ppi_detour2\\Debug\\tester.exe",
	L"C:\\Program Files\\Mozilla Firefox\\firefox.exe",
	L"C:\\Program Files\\Microsoft Office\\Office14\\WINWORD.EXE",
	L"C:\\Program Files\\Microsoft Visual Studio 14.0\\VC\\bin\\CL.exe",
	NULL};

BOOL __ppi_isNewAPIProcess = FALSE;
BOOL __ppi_checkedIsNewAPIProcess = FALSE;

BOOL ppi_isNewAPIProcess() {
	return ppi_isSpecialProcess(__ppi_checkedIsNewAPIProcess, __ppi_isNewAPIProcess, ppi_newAPIProcesses);
}






