/* * Portable Integrity Protection (PIP) System -
 * Copyright (C) 2015 Secure Systems Laboratory, Stony Brook University
 *
 * This file is part of Portable Integrity Protection (PIP) System.
 *
 * Portable Integrity Protection (PIP) System is free software: you can
 * redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Portable Integrity Protection (PIP) System is distributed in the hope that it
 * will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portable Integrity Protection (PIP) System.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef __PPI_HELPERCONNECTION_H__
#define __PPI_HELPERCONNECTION_H__

/* Communication to helper */

#include "ppi_packet.h"
#include "ppi_calls.h"

void ppi_helper_init();
void ppi_helper_fin();


int ppi_sendPkt2Helper(struct ppi_pkt *pkt);
int ppi_recvPktFromHelper(struct ppi_pkt *pkt);

#define ppi_helper_sendRecvCorrectly(_pkt, _response) ppi_helper_sendRecvCorrectlyWithLock((struct ppi_pkt *)&(_pkt), (struct ppi_pkt *)&(_response))
BOOL ppi_helper_sendRecvCorrectlyWithLock(struct ppi_pkt *_pkt, struct ppi_pkt *_response);

//#define ppi_helper_sendRecvCorrectly(_pkt, _response) ((ppi_sendPkt2Helper((struct ppi_pkt *)&(_pkt)) == 0) && (ppi_recvPktFromHelper((struct ppi_pkt *)&(_response)) == 0))

#define ppi_helper_decodeResult(_response, _result, _condition) \
	(_result = _response.result, \
	ppi_winapi_setError(_response.l_lastError),\
	(_condition))



#endif /* __PPI_HELPERCONNECTION_H__ */