/* * Portable Integrity Protection (PIP) System -
 * Copyright (C) 2015 Secure Systems Laboratory, Stony Brook University
 *
 * This file is part of Portable Integrity Protection (PIP) System.
 *
 * Portable Integrity Protection (PIP) System is free software: you can
 * redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Portable Integrity Protection (PIP) System is distributed in the hope that it
 * will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Portable Integrity Protection (PIP) System.  If not, see
 * <http://www.gnu.org/licenses/>.
 */

#ifndef __PPI_HELPER_H__
#define __PPI_HELPER_H__

#include "ppi_packet.h"
#include <windows.h>


#define ppi_helper_def_call(call) void process_ ##call(struct ppi_pkt_ ##call *req, struct ppi_pkt_ ##call ##_response *response, DWORD pid, HANDLE hPeerProcess)

ppi_helper_def_call(NtCreateFile);
ppi_helper_def_call(NtOpenDirectoryObject);
ppi_helper_def_call(NtSetInformationFile);
ppi_helper_def_call(NtQueryAttributesFile);

#ifdef WIN81
ppi_helper_def_call(NtQueryFullAttributesFile);
#endif

ppi_helper_def_call(NtOpenKeyEx);
ppi_helper_def_call(NtClose);
ppi_helper_def_call(DupToken);

#endif /* __PPI_HELPER_H__ */
