//
// Portable Integrity Protection (PIP) System -
// Copyright (C) 2015 Secure Systems Laboratory, Stony Brook University
//
// This file is part of Portable Integrity Protection (PIP) System.
//
// Portable Integrity Protection (PIP) System is free software: you can
// redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Portable Integrity Protection (PIP) System is distributed in the hope that it
// will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Portable Integrity Protection (PIP) System.  If not, see
// <http://www.gnu.org/licenses/>.
//

#include "ppi_packet.h"
#include "ppi_config.h"
#include "ppi_helper.h"
#include "ppi_utils.h"
#include "ppi_debug.h"

#include "ppi_version.h"


ppi_assign_originalFunc(NtQueryAttributesFile, L"ntdll");


ppi_helper_def_call(NtQueryAttributesFile) {
	
	
	OBJECT_ATTRIBUTES ObjectAttributes;
	UNICODE_STRING ObjectName;
	ppi_pkt_unpackObjectAttributes(req, ObjectAttributes, ObjectName);

	response->l_rv = OriginalNtQueryAttributesFile(&ObjectAttributes, &(response->FileInformation));

	ppi_pkt_unpackObjectAttributesCleanUp(ObjectAttributes);
}

#ifdef WIN81

ppi_assign_originalFunc(NtQueryFullAttributesFile, L"ntdll");

ppi_helper_def_call(NtQueryFullAttributesFile) {
	
	
	OBJECT_ATTRIBUTES ObjectAttributes;
	UNICODE_STRING ObjectName;
	ppi_pkt_unpackObjectAttributes(req, ObjectAttributes, ObjectName);

	response->l_rv = OriginalNtQueryFullAttributesFile(&ObjectAttributes, &(response->FileInformation));

	ppi_pkt_unpackObjectAttributesCleanUp(ObjectAttributes);
}

#endif
