//
// Portable Integrity Protection (PIP) System -
// Copyright (C) 2015 Secure Systems Laboratory, Stony Brook University
//
// This file is part of Portable Integrity Protection (PIP) System.
//
// Portable Integrity Protection (PIP) System is free software: you can
// redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Portable Integrity Protection (PIP) System is distributed in the hope that it
// will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Portable Integrity Protection (PIP) System.  If not, see
// <http://www.gnu.org/licenses/>.
//

#include "ppi_config.h"
#include "ppi_helperConnection.h"
#include "ppi_calls.h"
#include "ppi_debug.h"
#include "ppi_utils.h"
#include "ppi_level.h"
#include "ppi_redirect.h"


#include "ppi_regHandleManager.h"


/* Tell the helper that a handle is no longer valid */
ppi_winapi_prologue(NtCloseNew, NTSTATUS, 1,
  _In_      HANDLE, Handle
)

	NTSTATUS result;
	result = ppi_callOriginal(NtClose, Handle);

	if (result == STATUS_SUCCESS) {
		//PPI_INFO("Close finished with result %d", result);
		ppi_pkt_prepare_packets(NtClose, pkt, response);
		pkt.Handle = Handle;
		ppi_helper_sendRecvCorrectly(pkt, response);
		ppi_regHandleManager_handleClosed(Handle);
	}

	if (result == STATUS_SUCCESS) {
		ppi_closeFileHandle(Handle);
	}
out:
ppi_winapi_epilogue(NtCloseNew, result)
